<?php

// $Id: jobtrack_views.views.inc,v 1.2 2009/03/02 21:31:26 dubs Exp $

/**
 * Implementation of hook_views_data()
 */

function jobtrack_views_views_data() {

  // Jobtrack table
  $data['jobtrack_ticket']['table']['group']  = t('JobTrack Tickets');
  $data['jobtrack_ticket']['table']['base'] = array(
    'field' => 'nid',
    'title' => t('JobTrack Tickets'),
     'help' => t("JobTrack tickets contain ticketing info and can be related to nodes."),
     'weight' => -10,
   );
   $data['jobtrack_ticket']['table']['join'] = array(
     'node' => array(
       'left_field' => 'nid',
       'field' => 'nid',
     ),
   );
   // Node ID field.
   $data['jobtrack_ticket']['nid'] = array(
     'title' => t('JobTrack ticket'),
     'help' => t('A JobTrack ticket references a node.'),
     'relationship' => array(
       'base' => 'node',
       'field' => 'nid',
       'handler' => 'views_handler_relationship',
       'label' => t('JobTrack node'),
     ),
   );
   // State
   $data['jobtrack_ticket']['state'] = array(
     'title' => t('State ID'),
     'help' => t('The State ID of the ticket.'),
     'field' => array(
       'handler' => 'views_handler_field_numeric',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort_numeric',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_numeric',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_numeric',
     ),
   );
   // Priority
   $data['jobtrack_ticket']['priority'] = array(
     'title' => t('Priority ID'),
     'help' => t('The Priority ID of the ticket.'),
     'field' => array(
       'handler' => 'views_handler_field_numeric',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort_numeric',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_numeric',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_numeric',
     ),
   );
   // Client ID
   $data['jobtrack_ticket']['client'] = array(
     'title' => t('Client ID'),
     'help' => t('The Client ID of the ticket.'),
     'field' => array(
       'handler' => 'views_handler_field_numeric',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort_numeric',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_numeric',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_numeric',
     ),
   );
   // Assigned
   $data['jobtrack_ticket']['assigned'] = array(
     'title' => t('Assigned ID'),
     'help' => t('The Assigned ID of the ticket.'),
     'field' => array(
       'handler' => 'views_handler_field_numeric',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort_numeric',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_numeric',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_numeric',
     ),
   );



	// Job Track State Table
	$data['jobtrack_states']['table']['group'] = t('JobTrack Tickets');
	$data['jobtrack_states']['table']['join']['node'] = array(
		'left_table' => 'jobtrack_ticket',
  		'left_field' => 'state',
  		'field' => 'sid',
	);	
	// sid
	$data['jobtrack_states']['sid'] = array(
     'title' => t('States ID'),
     'help' => t('The state ID of the ticket.'),
	);
	// State
	$data['jobtrack_states']['state'] = array(
     'title' => t('State'),
     'help' => t('The state of the ticket, e.g. open, closed etc...'),
     'field' => array(
       'handler' => 'views_handler_field',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_jobtrack_state',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_string',
     ),
   );
   
   
   	// Job Track Client Table
	$data['jobtrack_client']['table']['group'] = t('JobTrack Tickets');
	$data['jobtrack_client']['table']['join']['node'] = array(
		'left_table' => 'jobtrack_ticket',
  		'left_field' => 'client',
  		'field' => 'clid',
	);	
	// clid
	$data['jobtrack_client']['clid'] = array(
     'title' => t('Client ID'),
     'help' => t('The Client ID of the ticket.'),
	);
	// Name
	$data['jobtrack_client']['name'] = array(
     'title' => t('Client Name'),
     'help' => t('The Client Name for the ticket.'),
     'field' => array(
       'handler' => 'views_handler_field',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_jobtrack_client',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_string',
     ),
   );

   	// Job Track Priority Table
	$data['jobtrack_priority']['table']['group'] = t('JobTrack Tickets');
	$data['jobtrack_priority']['table']['join']['node'] = array(
		'left_table' => 'jobtrack_ticket',
  		'left_field' => 'priority',
  		'field' => 'pid',
	);	
	// sid
	$data['jobtrack_priority']['pid'] = array(
     'title' => t('Priority ID'),
     'help' => t('The Priority ID of the ticket.'),
	);
	// State
	$data['jobtrack_priority']['priority'] = array(
     'title' => t('Priority'),
     'help' => t('The Priority for the ticket.'),
     'field' => array(
       'handler' => 'views_handler_field',
       'click sortable' => TRUE,
     ),
     'sort' => array(
       'handler' => 'views_handler_sort',
     ),
     'filter' => array(
       'handler' => 'views_handler_filter_jobtrack_priority',
     ),
     'argument' => array(
       'handler' => 'views_handler_argument_string',
     ),
   );


  return $data;
}

function jobtrack_views_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'jobtrack_views'),
    ),
    'handlers' => array(
      // filters
      'views_handler_filter_jobtrack_state' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
	  'views_handler_filter_jobtrack_client' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
	  'views_handler_filter_jobtrack_priority' => array(
        'parent' => 'views_handler_filter_in_operator',
      ),
    ),
  );
}
